/*

    gh|mdsPCI                                                   
    interface For Windows-NT                                          
    name : hi32nt.cpp                                                 
    Create : 98/05/20                                                 
    Update : 98/07/27      h^n烁[֕ύX                   
    Update : 98/09/11      Initial Ŏ~܂邱ƂL                 
                                                    gARVEST CO.,LTD. 

*/

/****************************************************************************/
/* hi32nt.cpp       Windows (R) HI-Net Driver DDL Interface Routines        */
/*                      NOTE: to be compiled with WINDOWS prolog options    */
/****************************************************************************/
//#define	_M_IX86	400


#include  <windows.h>
#include  <ole2.h>


#ifdef _WIN32
 #define CCONV _stdcall
 #define NOMANGLE
 #include <conio.h>
#else
 #define CCONV FAR PASCAL _export
 #define NOMANGLE
 #include <stdlib.h>
 #include <compobj.h>
 #include <dispatch.h>
 #include <variant.h>
 #include <olenls.h>
 #include <conio.h>
#endif
#include <winioctl.h>
#include <stddef.h>

// Device type           -- in the "User Defined" range."

#pragma pack(1)

    // The following is returned by IOCTL.  It is true if the read succeeds.
    BOOL    IoctlResult;

    // The following parameters are used in the IOCTL call

    HANDLE  hndFile[4];         // Handle to device, obtain from CreateFile

    ULONG   DataLength;
    LONG    IoctlCode;
    ULONG   ReturnedLength; // Number of bytes returned in output buffer
    ULONG   DataValue;
    /* Common types and typedefs  */
//typedef unsigned char   BYTE;
//typedef unsigned short  WORD;

    /* These are low level CDECL routines   */
#define	UC	unsigned char
#define	UI	unsigned short
#define	UL	unsigned long



/******************************************************************************\
*                              FUNCTION PROTOTYPES
\******************************************************************************/

UI	comopen( BYTE chn,UI bps,char protcol,UI synmode,UC sa,UC *id1,UC *id2,UI mode);
UI	comsend( BYTE chn,UC *senddt,UI dtlen,UC osa,UC oua,UI em);
UI	cmd_out(UI chn,UI dt);

UI data_read(UI bdno, UI chn, DWORD dpt, DWORD *dbuff);
UI data_write(UI bdno,UI chn, DWORD dpt, DWORD *dbuff);
UI flag_read(UI bdno, UI chn, DWORD dpt, DWORD *dbuff);
UI flag_write(UI bdno, UI chn, DWORD dpt, DWORD *dbuff);

short   data_in(UI bdno, UI chn, DWORD *dt);
short   data_out(UI bdno, UI chn, DWORD *dt, UI dlen);

short   cmd_rdy_check(UI bdno,UI chn);
short   cmd_end_check(UI bdno,UI chn);
short   cmd_set(UI bdno,UI chn, UC cmd, UI dlen);
short   cmd_send(UI bdno, UI chn, UC cmd, DWORD *dt, UI len);
short   cmd_recv(UI bdno,UI chn,UC cmd,DWORD *dt);
UI	sizeck(UC *sp);
void	memntof(UC *dp,UC *sp,UI len);

#define	SRBMAX	4096		/* Mf[^TCY */
#define	CHA	0
#define	CHB	1
#define	BOARDMAX	4

/* ob́@h^n@|[gR}h */
#define	PCRESET		0x80
#define	PCINTON		0x40
#define	PCINIT		0x01
#define	PCCANCEL	0x10
#define	PCCMD		0x08
#define	PCSTS		0x04
#define	PCSGOFF		0x00


/* LINE STATUS */
#define	BITCD		0x08
#define	BITCS		0x20
#define	BITDR		0x40

/* ʐMR}h */
#define	CNOP		0x00
#define	COPEN		0x01
#define	CCLOSE		0x02
#define	CTELON		0x03
#define	CMTELON		0x04
#define	CTELOFF		0x05
#define	CTIMER		0x06
#define	CRECV		0x07
#define	CSEND		0x08
#define	CSENDCK		0x09
#define	CRETRY		0x0a
#define	CRECVCLR	0x0b
#define	CSENDCLR	0x0c
#define	CVERGET		0x0d
#define	CMONGET		0x0e
#define	CHDLCDOSA	0x0f
#define	CBRECV		0x10
#define	CBSEND		0x11
#define	CDTCT		0x12
#define	CDOWNLOAD	0x13
#define	CPOLLON		0x14
#define	CPOLLOFF	0x15
#define	CPOLLRES	0x16
#define	CNWTELON	0x17
#define	CNWTELOFF	0x18
#define	CMDENDCK	0x19
#define	CMDRID		0x1a
#define	CRESET		0x24

#define	STCMRD		0x40		// Data Set By Board
#define	STDTRD		0x20		// Not Read Data From Board

/* vgRp\ */
struct Proto {
	UC	chno;		/* Channel No (0 to 1) */
	UC	trns_mode;	/* 0:ASYNC 1:COP 2:BOP */
	UC	protocol;	/* Protocol (0 to 5) */
					/* 1:NEC CLASS 2,2:BSC,3:NEC CLASS 3 */
	UC	dma_use;	/* CH-A DMA 0:NOT USE,1:USE */
	UC	baud_rate;	/* Baud rate (0:150,1:300,--,6:9600)*/
	UC	data_leng;	/* Data Length (8/7/6/5 bits) */
	UC	parity;		/* Parity (E:even/O:odd/N:none) */
	UC	stop_bits;	/* Stop bits (1/2/3) */
	UC	crc_type;	/* 0:NO CRC,1:BCC,2:CRC12,3:CRC16 */
	UC	data_format;	/* 0:NRZ,1:NRZI,FM1,FM0 */
	UC	clock_use;	/* 0:RT=I,1:R=O T=I,2:R=I T=O,3:RT=O */
	UC	hdlc_mode;	/* 0:free,1:NRM,2:ABM,4,ARM */
/*		  15      8       0
           em !!!!!!!!!!!!!!!!
              xxxxxxxxxxxxxxxx
              ||||||||||||||||__0    1H 0:Pǁ@1:Q
              |||||||||||||||___1    2H 0:O@@1:p
              ||||||||||||||____2    4H 0:    1:񓧉
              |||||||||||||_____3    8H 
              ||||||||||||______4   10H 0:f[^8ޯ 1:7ޯ
              |||||||||||_______5   20H 0:Q  1:S
              ||||||||||________6   40H MR[h 0:JIS8  1:JIS8->EBCDIC
              |||||||||_________7   80H MR[h 0:JIS8  1:EBCDIC->JIS8
              ||||||||__________8  100H 1:萧@bqbPQ 
              |||||||___________9  200H 1:萧@kqb
              ||||||___________10  400H 0:䕄 EBCDIC 1:ASCII
              |||||____________11  800H 1:èEVEN
              ||||_____________12 1000H 1:èODD
              |||______________13 2000H 1:_CA񓯊
              ||_______________14 4000H
              |________________15 8000H
*/
	UI	set_control;	
/*	  15      8       0
          em !!!!!!!!!!!!!!!!
             xxxxxxxxxxxxxxxx
             ||||||||||||||||__0    1H 1:whc@b^qǉ
             |||||||||||||||___1    2H 1:qdi@b^qǉ
             ||||||||||||||____2    4H 1:rqdi@b^qǉ
             |||||||||||||_____3    8H 1:th@b^qǉ
             ||||||||||||______4   10H 1:rhl@bCqhl@qǉ
             |||||||||||_______5   20H 1:to@bǉ
             ||||||||||________6   40H 1:gAhX`gp
             |||||||||_________7   80H 1:h@q폜
             ||||||||__________8  100H 1:h@b폜
             |||||||___________9  200H 1:WPQW
             ||||||___________10  400H 1:qrdsR}hǉia`̂݁j
             |||||____________11  800H 1:sdrsR}hǉ
             ||||_____________12 1000H 1:qc@qǉ
             |||______________13 2000H 1:
             ||_______________14 4000H 1:
             |________________15 8000H 1:
*/
	UI	set_control2;
	UI	set_timefil;
	UI	set_maxlen;		/* MAX RECORD LENGTH */
	UC	set_mojyuro;
	UC	set_winsize;		/* gckbWX */
	UC	pdumy_2[60];

	UI	sync_count;	
	UC	sync_code[2];	
	UI	padl_count;	
	UC	padl_code[2];	
	UI	padt_count;	
	UC	padt_code[2];	
	UI	id1_count;
	UC	id1_code[128];		/* ID1 ISAUA  OR IUA */
	UI	id2_count;
	UC	id2_code[128];		/* ID2 OUA */
	UC	sa_code;		/* SA */
	UC	pdumy_3;

	UC	XON_char;
	UC	XOFF_char;
	UI	XON_limit;
	UI	XOFF_limit;

	UI	tm1time;
	UI	tm2time;
	UI	tm3time;
	UI	tm4time;
	UI	tm5time;		/* CS AFTER SEND START TIME */
	UI	wabttime;

	UI	seltmrtry;
	UI	selnkrtry;
	UI	trstmrtry;
	UI	trsnkrtry;
	UI	wabtrtry;
} PROT[BOARDMAX*2];

/* f[^@@CXe[^X */
struct wdct{
	UI	chsdpt;		/* bg`AaMf[^|Cg */
	UI	chsdct;		/* bg`AaMf[^ */
	UI	chrdct;		/* bg`AaMf[^ */
	UI	chstatus;	/* bg`AaXe[^X */
	UC	line_status;	/* Line Status 40H:DR ON,20H:CS ON,08H:CD ON */
    UC  dmy[3];
} WDTCT[BOARDMAX*2];

/* ʐM */
struct wmcomdt {
	UI	hbuf_link;
	UI	hbuf_length;		/* Mf[^ */
	UI	hbuf_endmark;		/* M@dl */
	UC	hbuf_mark;
	UC	hbuf_err;		/* MG[ */
	UC	hbuf_sa;		/* M@r` */
	UC	hbuf_ua;		/* M@t` */
	UC	hbuf_data[SRBMAX];	/* Mf[^ */
} WCOMBF[BOARDMAX*2];
#define	HDSIZE	10
/* R}h@obt@ */
struct wcmd{
	UC	cmddt;		/* bgR}hf[^ */
	UC	stsdt;		/*  */
	UI	dtlen;		/*  */
} WMCMD[BOARDMAX*2];

/* ׸ރobt@ */
struct rflgdt{
	UC	flag[4];	/* bg`AatO|Cg */
} RFLG[BOARDMAX];
struct wflgdt{
    UC flag[4];
} WFLG[BOARDMAX];


/* f[^ */
UC	version[21];	/* o[W */


DWORD	MEMAD[BOARDMAX] = {0,0,0,0};

UI	RECSIZE[BOARDMAX * 2];
UI	PADLSUU[BOARDMAX * 2];
UI	PADTSUU[BOARDMAX * 2];
UC	PADLDAT[BOARDMAX * 2];
UC	PADTDAT[BOARDMAX * 2];
UC	SYNCCOD[BOARDMAX * 2];
UI	SYNCSUU[BOARDMAX * 2];

UC	OPENFLAG[BOARDMAX * 2];

UC	padr[BOARDMAX * 2];
UI	hdosa[2];

/*****************************************************************************
*  FUNCTION:    DllMain
*
*  INPUTS:      hDLL       - handle of DLL
*               dwReason   - indicates why DLL called
*               lpReserved - reserved
*
*  RETURNS:     TRUE (always, in this example.)
*
*               Note that the retuRn value is used only when
*               dwReason = DLL_PROCESS_ATTACH.
*
*               Normally the function would return TRUE if DLL initial-
*               ization succeeded, or FALSE it it failed.
*
*  GLOBAL VARS: ghMod - handle of DLL (initialized when PROCESS_ATTACHes)
*
*  COMMENTS:    The function will display a dialog box informing user of
*               each notification message & the name of the attaching/
*               detaching process/thread. For more information see
*               "DllMain" in the Win32 API reference.
*
******************************************************************************/

BOOL WINAPI DllMain (HINSTANCE hDLL, DWORD dwReason, LPVOID lpReserved)
{
  switch (dwReason)
  {
    case DLL_PROCESS_ATTACH:
    {
      //
      // DLL is attaching to the address space of the current process.
      //

      break;
    }

    case DLL_THREAD_ATTACH:

      //
      // A new thread is being created in the current process.
      //

      break;

    case DLL_THREAD_DETACH:

      //
      // A thread is exiting cleanly.
      //

      break;

    case DLL_PROCESS_DETACH:

      //
      // The calling process is detaching the DLL from its address space.
      //
      break;
  }

return TRUE;
}


 
/************************************************************************
*                                                                       *
*    ֐	UI initial( UI *ioaddr)                                     *
*                                                                       *
*    T  v	CjVCY                                              *
*                                                                       *
*************************************************************************/
NOMANGLE UI CCONV initial(UI *ioaddr)
{
	UI	i,b;
//	UL	j;
    DWORD      err;


    for (b = 0;b < BOARDMAX;b++){
        if (ioaddr[b] == 0){
            continue;
	// break;
        }
        else{
            switch (b){
		    case 0:
		     	hndFile[b] = CreateFile(
                             "\\\\.\\HiIo",          // Open the Device "file"
                             GENERIC_READ | GENERIC_WRITE,
                             FILE_SHARE_READ,
                             NULL,
                             OPEN_EXISTING,
                             0,
                            NULL
                );
				break;
		    case 1:
		     	hndFile[b] = CreateFile(
                             "\\\\.\\HiIo1",          // Open the Device "file"
                             GENERIC_READ | GENERIC_WRITE,
                             FILE_SHARE_READ,
                             NULL,
                             OPEN_EXISTING,
                             0,
                            NULL
                );
				break;
		    case 2:
		     	hndFile[b] = CreateFile(
                             "\\\\.\\HiIo2",          // Open the Device "file"
                             GENERIC_READ | GENERIC_WRITE,
                             FILE_SHARE_READ,
                             NULL,
                             OPEN_EXISTING,
                             0,
                            NULL
                );
				break;
		    case 3:	
		     	hndFile[b] = CreateFile(
                             "\\\\.\\HiIo3",          // Open the Device "file"
                             GENERIC_READ | GENERIC_WRITE,
                             FILE_SHARE_READ,
                             NULL,
                             OPEN_EXISTING,
                             0,
                            NULL
                );
				break;
           }
           if (hndFile[b] == INVALID_HANDLE_VALUE)//Was the device opened?
           {
               err = GetLastError();
               return((UI)err & 0xffff | 0x8000);
           }
           MEMAD[b] = 1;
      }
    }

    for (i = 0; i < BOARDMAX; i++){
        if (MEMAD[i] != 0){
            WFLG[i].flag[0] = 1;
            WFLG[i].flag[1] = 1;
            WFLG[i].flag[2] = 1;
            WFLG[i].flag[3] = 1;
            RFLG[i].flag[0] = 0;
            RFLG[i].flag[1] = 0;
            RFLG[i].flag[2] = 0;
            RFLG[i].flag[3] = 0;     
            flag_write(i, 0, 0,(DWORD *) &WFLG[i]);
            b = cmd_send(i,0,CRESET,NULL,0); //I00.01.15
            Sleep(1000);

            flag_write(i, 0, 0,(DWORD *) &WFLG[i]);
	}
    }
   
    for (i = 0; i < BOARDMAX*2; i++){
        RECSIZE[i] = 2048;
        PADLSUU[i] = 2;
        PADTSUU[i] = 2;
        PADLDAT[i] = 0xaa;
        PADTDAT[i] = 0xff;
        SYNCCOD[i] = 0;
        SYNCSUU[i] = 4;
        OPENFLAG[i] = 0;
    }
//    if (hndFile[0] != 0)
//        cmd_recv(0,0,CVERGET,(DWORD *)version);

    return(0);
}

NOMANGLE  UI CCONV   hiunload(BYTE chn)
{
	UI	bdno;
	UI	bdchn;

	bdno = chn/2;
	bdchn = chn % 2;
    if (!CloseHandle(hndFile[bdno]))              // Close the Device "file".
			 return(1);
    return(0);
}

void hdlcopen(void) { return;}
void hdlcsetm(void) { return;}
void hdlcgets(void) { return;}

 
    /********************************/
    /*  Block Size Set              */
    /*      Channel Block Size Set  */
    /*      Returns 0 or error code */
    /********************************/
NOMANGLE UI CCONV bsizeset(BYTE chn,UI blen)
{
     RECSIZE[chn] = blen;
     return(0);
}

/*****************************************************************************
*                                                                            *
*   ֐	UI padset( char chn,UC lpad,UI lpadlen,UC tpad,UI tpadlen)   *
*                                                                            *
*   T  v	bg@pbhZbg                                           *
*                                                                            *
******************************************************************************/
NOMANGLE UI CCONV padset(BYTE chn,UC lpad,UI lpadlen,UC tpad,UI tpadlen)
{
	PADLDAT[chn] = lpad;
	PADLSUU[chn] = lpadlen;
	PADTDAT[chn] = tpad;
	PADTSUU[chn] = tpadlen;
	return(0);
}

/*****************************************************************************
*									     *
*    ֐	int syncset( char chn,UC synchr,UI syncct)  		     *
*									     *
*    T  v	bg@VNZbg					     *
*									     *
******************************************************************************/
NOMANGLE UI CCONV syncset(BYTE chn,UC synchr,UI syncct)
{
	if (synchr != 0)
		SYNCCOD[chn] = synchr;
	SYNCSUU[chn] = syncct;
	return(0);
}

/*****************************************************************************
*                                                                            *
*    ֐	UI bscopen( char chn,char *id1,char *id2,UI mode,            *
*                       UI synmode, UI bps)                                  *
*                                                                            *
*    T  v	bg@I[v                                               *
*                                                                            *
******************************************************************************/
NOMANGLE UI	CCONV bscopen(BYTE chn,UC *id1,UC *id2,UI mode,UI synmode,UI bps)
{
	return	(comopen(chn,bps,2,synmode,0,id1,id2,mode));
}

/************************************************************************
*                                                                       *
*    ֐	UI nec2open(char chn,UI synmode, UI bps,                *
*                             char *isaua, UI mode)                     *
*                                                                       *
*    T  v	bg@I[v                                          *
*                                                                       *
*************************************************************************/
NOMANGLE UI  CCONV nec2open( BYTE chn,UI synmode, UI bps, UC *isaua,UI mode)
{
	return	(comopen(chn,bps,1,synmode,0,isaua,0,mode));
}

/*****************************************************************************
*                                                                            *
*    ֐  UI nec3open( char chn, UI synmode, UI bps,UI sa,UC *iua,        *
*                           UC *oua,UI mode)                                 *
*                                                                            *
*    T  v  bg I[v                                                   *
*                                                                            *
******************************************************************************/
NOMANGLE UI	CCONV nec3open( BYTE chn,UI synmode,UI bps,UI sa,UC *iua,UC *oua,UI mode)
{
	return	(comopen(chn,bps,3,synmode,(UC)sa,iua,oua,mode));
}


/************************************************************************
*                                                                       *
*    ֐ UI comopen( char chn,UI bps,char protcol,UI synmode,char sa,*
*                       char *id1,char *id2,UI mode)                    *
*                                                                       *
*    T  v  bg I[v                                              *
*                                                                       *
*************************************************************************/
UI	comopen( BYTE chn,UI bps,char protcol,UI synmode,UC sa,UC *id1,UC *id2,UI mode)
{
	UI	i;
	UI	bdno;
	UI	bdchn;

	bdno = chn/2;
	bdchn = chn % 2;

	if (OPENFLAG[chn] != 0)
		return(0x8005);
	if (MEMAD[bdno] == 0)
		return(0x8007);

	PROT[chn].chno = (char)bdchn;  /* Chn No(0 to 1) */
	if (synmode == 0)
		PROT[chn].trns_mode =(char)synmode; /* 0:ASYNC 1:COP 2:BOP */
	else
		PROT[chn].trns_mode =(char)1; /* 0:ASYNC 1:COP 2:BOP */

	PROT[chn].protocol = protcol; 	/* Protocol(0 to 5) */
				/* 1:NEC CLASS 2,2:BSC,3:NEC CLASS 3,4:HDLC */
	PROT[chn].dma_use = 0;	/* CH-A DMA 0:NOT USE,1:USE */


	/* Baud rate (0:150,1:300,--,6:9600)*/
	PROT[chn].baud_rate = (UC)bps; /* Baud rate (0:150,1:300,--,6:9600)*/

	PROT[chn].data_leng = 8;	/*Data Length (8/7/6/5 bits)*/
	PROT[chn].parity = 'N';		/*Parity(E:even/O:odd/N:none)*/

	PROT[chn].stop_bits = 1;	/* Stop bits (1/2/3) */

	PROT[chn].data_format = 0;	/* 0:NRZ,1:NRZI,FM1,FM0 */

	switch(synmode){
		case 0:	
		    PROT[chn].clock_use = 0;	/* 0:RT=I,1:R=O T=I,2:R=I T=O,3:RT=O */
		    break;
		case 1:
		    PROT[chn].clock_use = 1;	/* 0:RT=I,1:R=O T=I,2:R=I T=O,3:RT=O */
		    break;
		case 2:
		    PROT[chn].clock_use = 3;	/* 0:RT=I,1:R=O T=I,2:R=I T=O,3:RT=O */
	}

/*        15      8       0
        em !!!!!!!!!!!!!!!!
           xxxxxxxxxxxxxxxx
           ||||||||||||||||__0    1H 0:Pǁ@1:Q
           |||||||||||||||___1    2H 0:O@@1:p
           ||||||||||||||____2    4H 0:    1:񓧉
           |||||||||||||_____3    8H 
           ||||||||||||______4   10H 0:f[^8ޯ 1:7ޯ
           |||||||||||_______5   20H 0:Q  1:S
           ||||||||||________6   40H MR[h 0:JIS8  1:JIS8->EBCDIC
           |||||||||_________7   80H MR[h 0:JIS8  1:EBCDIC->JIS8
           ||||||||__________8  100H 1:萧@bqbPQ 
           |||||||___________9  200H 1:萧@kqb
           ||||||___________10  400H 0:䕄 EBCDIC 1:ASCII
           |||||____________11  800H 1:èEVEN
           ||||_____________12 1000H 1:èODD
           |||______________13 2000H
           ||_______________14 4000H
           |________________15 8000H
*/

	PROT[chn].set_control = mode;

	PROT[chn].set_control2 = 0x00;

	PROT[chn].set_timefil = 0x200;
	PROT[chn].set_maxlen = RECSIZE[chn];

	if (SYNCCOD[chn] == 0){
	    if (protcol == 2){
	        PROT[chn].sync_code[0] = 0x32;
	        PROT[chn].sync_code[1] = 0x32;
	    }
	    else{
	        PROT[chn].sync_code[0] = 0x16;
	        PROT[chn].sync_code[1] = 0x16;
	    }
	}
	else{
	    PROT[chn].sync_code[0] = SYNCCOD[chn];
	    PROT[chn].sync_code[1] = SYNCCOD[chn];
	}
        PROT[chn].sync_count = SYNCSUU[chn];

	PROT[chn].padl_count = PADLSUU[chn];
	PROT[chn].padl_code[0] = PADLDAT[chn];
	PROT[chn].padl_code[1] = PADLDAT[chn];
	PROT[chn].padt_count = PADTSUU[chn];
	PROT[chn].padt_code[0] = PADTDAT[chn];
	PROT[chn].padt_code[1] = PADTDAT[chn];

	switch( protcol ){
	    case 1:		/* NEC Class 2 */
                if (PROT[chn].trns_mode == 1){
			  switch (mode & 0x300){
		        case 0x000:
			      PROT[chn].crc_type = 2;	/* crc12 */
			      break;
		        case 0x100:
			      PROT[chn].crc_type = 3;	/* crc16 */
			      break;
			  }
		  }     
		  else{
			PROT[chn].crc_type = 1;	/* LRC */
		  }		

		i = sizeck(id1);
		PROT[chn].id1_count = i;
		memcpy((UC *)&PROT[chn].id1_code,id1,i); /*ISA,iUA*/
		break;
	    case 2:		/* BSC */
		switch (mode & 0x300){
		    case 0x000:
			PROT[chn].crc_type = 3;	/* crc16 */
			break;
		    case 0x100:
			PROT[chn].crc_type = 2;	/* crc12 */
			break;
		    case 0x200:
			PROT[chn].crc_type = 1;	/* LRC */
			break;
		}

		i = sizeck(id1);
		PROT[chn].id1_count = i;
		memcpy((UC *)&PROT[chn].id1_code,id1,i);
		i = sizeck(id2);
		PROT[chn].id2_count = i;
		memcpy((UC *)&PROT[chn].id2_code,id2,i);
		break;
	    case 3:		/* NEC Class 3 */
          if (PROT[chn].trns_mode == 1){
			  switch (mode & 0x300){
		        case 0x000:
			      PROT[chn].crc_type = 2;	/* crc12 */
			      break;
		        case 0x100:
			      PROT[chn].crc_type = 3;	/* crc16 */
			      break;
			  }
          }
          else{
			PROT[chn].crc_type = 1;	/* LRC */
		  }		

		PROT[chn].sa_code = (UC)sa;	/* SA */

		i = sizeck(id1);
		PROT[chn].id1_count = i;
		memcpy((UC *)&PROT[chn].id1_code,id1,i); /* iua */
		i = sizeck(id2);
		PROT[chn].id2_count = i;
		memcpy((UC *)&PROT[chn].id2_code,id2,i); /* oua */
		break;
	    default:
		break;
	}
	PROT[chn].XON_char = 0;
	PROT[chn].XOFF_char = 0;
	PROT[chn].XON_limit = 0;
	PROT[chn].XOFF_limit = 0;

	PROT[chn].tm1time = 200;
	PROT[chn].tm2time = 20;
	PROT[chn].tm3time = 30;
	PROT[chn].tm4time = 10;
	PROT[chn].tm5time = 0;
	PROT[chn].wabttime = 20;

	PROT[chn].seltmrtry = 7;
	PROT[chn].selnkrtry = 7;
	PROT[chn].trstmrtry = 7;
	PROT[chn].trsnkrtry = 7;
	PROT[chn].wabtrtry = 7;

	i = cmd_send(bdno,bdchn,COPEN,(DWORD *)&PROT[chn],sizeof(PROT[chn]));

	if (i != 0)
	    i |= 0x8000;

	OPENFLAG[chn] = 1;
	return(0);
}


/************************************************************************
*                                                                       *
*     ֐    UI chclose( char chn)                                   *
*                                                                       *
*     T  v   bg  N[Y                                           *
*                                                                       *
*************************************************************************/
NOMANGLE UI	CCONV chclose(BYTE chn)
{
	UI	i;
	UI	bdno;
	UI	bdchn;

	bdno = chn/2;
	bdchn = chn % 2;

	if (MEMAD[bdno] == 0)
		return(0x8007);
	i = cmd_send(bdno,bdchn,CCLOSE,NULL,0);
	OPENFLAG[chn] = 0;
	return(0);
}


/************************************************************************
*                                                                       *
*    ֐ UI telon( char chn,char *telno,UI time)                     *
*                                                                       *
*    T  v sdk nm                                                 *
*                                                                       *
*************************************************************************/
NOMANGLE UI	CCONV telon(BYTE chn,UC *telno,UI time)
{
	UC	*dp;
	UI	i,len;
	UI	bdno;
	UI	bdchn;

	bdno = chn/2;
	bdchn = chn % 2;
	if (MEMAD[bdno] == 0)
		return(0x8007);

	if (OPENFLAG[chn] == 0)
		return(0x8006);

/* TELON */
	len = sizeck(telno);
	WCOMBF[chn].hbuf_length = len;
	WCOMBF[chn].hbuf_endmark = time;
	dp = (UC *)WCOMBF[chn].hbuf_data;
	memcpy(dp,telno,len);

	i = cmd_send(bdno,bdchn,CTELON,(DWORD *)&WCOMBF[chn],len+HDSIZE);
	return(i);
}

/************************************************************************
*                                                                       *
*    ֐ UI nwtelon( char chn,char *telno,UI time)                   *
*                                                                       *
*    T  v ҂sdk nm                                         *
*                                                                       *
*************************************************************************/
NOMANGLE UI	CCONV nwtelon(BYTE chn,UC *telno,UI time)
{
	UC	*dp;
	UI	i,len;
	UI	bdno;
	UI	bdchn;

	bdno = chn/2;
	bdchn = chn % 2;
	if (MEMAD[bdno] == 0)
		return(0x8007);

	if (OPENFLAG[chn] == 0)
		return(0x8006);

/* TELON */
	len = sizeck(telno);
	WCOMBF[chn].hbuf_length = len;

	if (time == 0)
	    time = 600;
	WCOMBF[chn].hbuf_endmark = time;
	dp = (UC *)WCOMBF[chn].hbuf_data;
	memcpy(dp,telno,len);

	i = cmd_send(bdno,bdchn,CNWTELON,(DWORD *)&WCOMBF[chn],len+HDSIZE);
	return(i);
}

/************************************************************************
*                                                                       *
*    ֐  UI mtelon( char chn)                                       *
*                                                                       *
*    T  v	蓮dbڑAdbM҂                                  *
*                                                                       *
*************************************************************************/
NOMANGLE UI	CCONV mtelon(BYTE chn)
{
	UI	i;
	UI	bdno;
	UI	bdchn;

	bdno = chn/2;
	bdchn = chn % 2;
	if (MEMAD[bdno] == 0)
		return(0x8007);

	if (OPENFLAG[chn] == 0)
		return(0x8006);

/* M-TELON */

	i = cmd_send(bdno,bdchn,CMTELON,NULL,0);
	return(i);
}

/************************************************************************
*                                                                       *
*    ֐ UI teloff( char chn)                                        *
*                                                                       *
*    T  v dbڒf                                                    *
*                                                                       *
*************************************************************************/
NOMANGLE UI	CCONV teloff(BYTE chn)
{
	UI	i;
	UI	bdno;
	UI	bdchn;

	bdno = chn/2;
	bdchn = chn % 2;
	if (MEMAD[bdno] == 0)
		return(0x8007);

	if (OPENFLAG[chn] == 0)
		return(0x8006);

/* TELOFF */

	i = cmd_send(bdno,bdchn,CTELOFF,NULL,0);
	return(i);
}

/************************************************************************
*                                                                       *
*    ֐ UI nwteloff( char chn)                                      *
*                                                                       *
*    T  v ҂dbڒf                                            *
*                                                                       *
*************************************************************************/
NOMANGLE UI	CCONV nwteloff(BYTE chn)
{
	UI	i;
	UI	bdno;
	UI	bdchn;

	bdno = chn/2;
	bdchn = chn % 2;
	if (MEMAD[bdno] == 0)
		return(0x8007);

	if (OPENFLAG[chn] == 0)
		return(0x8006);

/* TELOFF */

	i = cmd_send(bdno,bdchn,CNWTELOFF,NULL,0);
	return(i);
}

/*****************************************************************************
*                                                                            *
*    ֐ UI nec2send( char chn,UC *senddt,UI dtlen,UC osa,UC oua,UI em)   *
*                                                                            *
*    T  v bg  f[^M                                                 *
*                                                                            *
******************************************************************************/
NOMANGLE UI  CCONV nec2send(BYTE chn,UC *senddt,UI dtlen,UC osa,UC oua,UI endm)
{
	return(comsend(chn,senddt,dtlen,osa,oua,endm));
}

/*****************************************************************************
*                                                                            *
*    ֐ UI  bscsend( char chn,UC *senddt,UI dtlen,UI em)                 *
*                                                                            *
*    T  v bg  f[^M                                                 *
*                                                                            *
******************************************************************************/
NOMANGLE UI	CCONV bscsend(BYTE chn,UC *senddt,UI dtlen,UI endm)
{
	return(comsend(chn,senddt,dtlen,0x00,0x00,endm));
}

/*****************************************************************************
*                                                                            *
*    ֐ UI  nec3send( char chn,UC *senddt,UI dtlen,UC oua,UI em)         *
*                                                                            *
*    T  v bg f[^M                                                  *
*                                                                            *
******************************************************************************/
NOMANGLE UI CCONV nec3send(BYTE chn,UC *senddt,UI dtlen,UC oua,UI endm)
{
	return(comsend(chn,senddt,dtlen,0x00,oua,endm));
}

/*****************************************************************************
*                                                                            *
*    ֐ UI comsend( char chn,UC *senddt,UI dtlen,UC osa,UC oua,UI em)    *
*                                                                            *
*    T  v bg f[^M                                                  *
*                                                                            *
******************************************************************************/
UI comsend( BYTE chn,UC *senddt,UI dtlen,UC osa,UC oua,UI em)
{
	UC	*dp;
	UI	i;
	UI	bdno;
	UI	bdchn;

	bdno = chn/2;
	bdchn = chn % 2;
	if (MEMAD[bdno] == 0)
		return(0x8007);

	if (OPENFLAG[chn] == 0)
		return(0x8006);

	i = cmd_recv(bdno,bdchn,CDTCT,(DWORD *)&WDTCT[chn]);
	if ((WDTCT[chn].line_status & BITDR) != BITDR){ /* LINK OFF */
	    return(0x8003);
	}
	WCOMBF[chn].hbuf_sa = osa;
	WCOMBF[chn].hbuf_ua = oua;

	WCOMBF[chn].hbuf_length = dtlen;
	WCOMBF[chn].hbuf_endmark = em;
	dp = (UC *)WCOMBF[chn].hbuf_data;
	memcpy(dp,senddt,dtlen);

	i = cmd_send(bdno,bdchn,CSEND,(DWORD *)&WCOMBF[chn],dtlen+HDSIZE);
	if (i != 0)
	    i |= 0x8000;
	return(i);
}



/*****************************************************************************
*                                                                            *
*    ֐ UI sendck( char chn)                                             *
*                                                                            *
*    T  v bg f[^M`FbN                                          *
*                                                                            *
******************************************************************************/
NOMANGLE UI CCONV sendck(BYTE chn)
{
	UI	i;
	UI	j,bdno;
	UI	bdchn;

	bdno = chn/2;
	bdchn = chn % 2;
	if (MEMAD[bdno] == 0)
		return(0x8007);

	if (OPENFLAG[chn] == 0)
		return(0x8006);

	i = cmd_recv(bdno,bdchn,CDTCT,(DWORD *)&WDTCT[chn]);
	if ((WDTCT[chn].line_status & BITDR) != BITDR){ /* LINK OFF */
	    return(0x8003);
	}
	j = WDTCT[chn].chsdpt;
	i = cmd_recv(bdno,bdchn,CSENDCK,NULL);
	if ((j != 0) && (i == 0))
		return(1);
	if (i == 1){
	    return(i);
	}
	
	if (i != 0)
	    i |= 0x8000;
	return(i);
}

/************************************************************************
*									*
*    ֐	int rdtck( char chn)					*
*									*
*    T  v	bg@f[^M@					*
*									*
*	ret = 0x0000 ... rcv data nothing				*
*	    = 0x!!!!!!!!!!!!! ... M				*
*									*
*************************************************************************/
NOMANGLE UI CCONV rdtck(BYTE chn)
{
	int	i;
	UI	bdno;
	UI	bdchn;

	bdno = chn/2;
	bdchn = chn % 2;
	if (MEMAD[bdno] == 0)
		return(0x8007);

	if (OPENFLAG[chn] == 0)
		return(0x8006);

	i = cmd_recv(bdno,bdchn,CDTCT,(DWORD *)&WDTCT[chn]);
	return(WDTCT[chn].chrdct);
}

/************************************************************************
*                                                                       *
*    ֐ UI recv( char chn,UC *recvdt)                               *
*                                                                       *
*    T  v bg f[^M                                             *
*                                                                       *
*	ret = 0x0000 ... rcv data nothing                               *
*       = 0??!!!!!!!!!!!!! ... rcv ok                                   *
*            !!!!!!!!!!!!! ... Text length(OK)                          *
*          ??              ... 0   etx                                  *
*          ??              ... 1   etb                                  *
*          ??              ... 2   eot                                  *
*      = 0x80** ... err( ** = err_code )                                *
*************************************************************************/
NOMANGLE UI	CCONV hrecv(BYTE chn,UC *recvdt)
{
	UC	*dp;
	UI	i;
	UI	bdno;
	UI	bdchn;

	bdno = chn/2;
	bdchn = chn % 2;
	if (MEMAD[bdno] == 0)
		return(0x8007);

	if (OPENFLAG[chn] == 0)
		return(0x8006);

	i = cmd_recv(bdno,bdchn,CDTCT,(DWORD *)&WDTCT[chn]);
	if (WDTCT[chn].chrdct == 0){
	    if ((WDTCT[chn].line_status & BITDR) != BITDR){ /* LINK OFF */
		return(0x8003);
	    }
	    return(0);
	}
	cmd_recv(bdno,bdchn,CRECV,(DWORD *)&WCOMBF[chn]);

	i = WCOMBF[chn].hbuf_err & 0xff;
	if ( i != 0){
	    return(i | 0x8000);
	}

	if (WCOMBF[chn].hbuf_endmark / 256 == 0x40){
	    return(0x4000);
	}
	dp = (UC *)WCOMBF[chn].hbuf_data;
	i = WCOMBF[chn].hbuf_length;

	memcpy(recvdt,dp,i);

	i |= WCOMBF[chn].hbuf_endmark & 0x6000;

	return(i);
}

/************************************************************************
*                                                                       *
*    ֐ UI hrecvx( char chn,UC *recvdt)                             *
*                                                                       *
*    T  v	bg@f[^MiOf[^̎Mׁ̈j		*
*                                                                       *
*	ret = 0x0000 ... rcv data nothing                               *
*       = 0??!!!!!!!!!!!!! ... rcv ok                                   *
*            !!!!!!!!!!!!! ... Text length(OK)                          *
*          ??              ... 3   etx                                  *
*          ??              ... 1   etb                                  *
*          ??              ... 2   eot                                  *
*      = 0x80** ... err( ** = err_code )                                *
*************************************************************************/
NOMANGLE UI	CCONV hrecvx(BYTE chn,UC *recvdt)
{
	UC	*dp;
	UI	i;
	UI	bdno;
	UI	bdchn;

	bdno = chn/2;
	bdchn = chn % 2;
	if (MEMAD[bdno] == 0)
		return(0x8007);

	if (OPENFLAG[chn] == 0)
		return(0x8006);

	i = cmd_recv(bdno,bdchn,CDTCT,(DWORD *)&WDTCT[chn]);
	if (WDTCT[chn].chrdct == 0){
	    if ((WDTCT[chn].line_status & BITDR) != BITDR){ /* LINK OFF */
		return(0x8003);
	    }
	    return(0);
	}
	cmd_recv(bdno,bdchn,CRECV,(DWORD *)&WCOMBF[chn]);

	i = WCOMBF[chn].hbuf_err & 0xff;
	if ( i != 0){
	    return(i | 0x8000);
	}

	if (WCOMBF[chn].hbuf_endmark / 256 == 0x40){
	    return(0x4000);
	}
	dp = (UC *)WCOMBF[chn].hbuf_data;
	i = WCOMBF[chn].hbuf_length;

	memcpy(recvdt,dp,i);

	if ((WCOMBF[chn].hbuf_endmark & 0x6000) == 0)
		WCOMBF[chn].hbuf_endmark |= 0x6000;
	i |= WCOMBF[chn].hbuf_endmark & 0x6000;

	return(i);
}


/******************************************************************************
*                                                                             *
*    ֐ void timerset(char chn,UI tmr1,UI tmr2,UI tmr3,UI tmr4,           *
*                         UI tmr5)                                            *
*                                                                             *
*    T@v    ^C}[Zbg                                                 *
*                                                                             *
*******************************************************************************/
NOMANGLE UI 	CCONV timerset(BYTE chn, UI tmr1,UI tmr2,UI tmr3,UI tmr4,UI tmr5)
{
	UI	bdno;
	UI	bdchn;

	bdno = chn/2;
	bdchn = chn % 2;
	if (MEMAD[bdno] == 0)
		return(0x8007);

    if (tmr1 != 0)
	    PROT[chn].tm1time = tmr1;
    if (tmr2 != 0)
    	PROT[chn].tm2time = tmr2;
    if (tmr3 != 0)
    	PROT[chn].tm3time = tmr3;
    if (tmr5 != 0)
    	PROT[chn].tm4time = tmr5;
//	PROT[chn].tm5time = 0;
    if (tmr4 != 0)
     	PROT[chn].wabttime = tmr4;

	return(cmd_send(bdno,bdchn,CTIMER,(DWORD *)&PROT[chn].tm1time,12));
}


/**************************************************************************
*                                                                         *
*  ֐ void retryset(char chn,UI rt1,UI rt2,UI rt3,UI rt4,UI rt5)      *
*                                                                         *
*  T  v  gCZbg                                                 *
*                                                                         *
***************************************************************************/
NOMANGLE UI   CCONV retryset(BYTE chn,UI rt1,UI rt2,UI rt3,UI rt4,UI rt5)
{
	UI	bdno;
	UI	bdchn;

	bdno = chn/2;
	bdchn = chn % 2;
	if (MEMAD[bdno] == 0)
		return(0x8007);

	PROT[chn].seltmrtry = rt1;
	PROT[chn].selnkrtry = rt2;
	PROT[chn].trstmrtry = rt3;
	PROT[chn].trsnkrtry = rt4;
	PROT[chn].wabtrtry = rt5;

	return(cmd_send(bdno,bdchn,CRETRY,(DWORD *)&PROT[chn].seltmrtry,10));
}

/**************************************************************************
*									  *
* ֐ int rbfclr(char chn)						  *
*									  *
*    T  v	Mobt@NA@					  *
*									  *
***************************************************************************/
NOMANGLE UI   CCONV rbfclr(BYTE chn)
{
	UI	i;
	UI	bdno;
	UI	bdchn;

	bdno = chn/2;
	bdchn = chn % 2;
	if (MEMAD[bdno] == 0)
		return(0x8007);

	i = cmd_send(bdno,bdchn,CRECVCLR,NULL,0);
	return(0);
}

/**************************************************************************
*									  *
* ֐ int sbfclr(char chn)						  *
*									  *
*    T  v	Mobt@NA@					  *
*									  *
***************************************************************************/
NOMANGLE UI   CCONV sbfclr(BYTE chn)
{
	UI	i;
	UI	bdno;
	UI	bdchn;

	bdno = chn/2;
	bdchn = chn % 2;
	if (MEMAD[bdno] == 0)
		return(0x8007);

	i = cmd_send(bdno,bdchn,CSENDCLR,NULL,0);
	return(0);
}


/************************************************************************
*                                                                       *
*    ֐ UI verget( char chn,char *ver)                              *
*                                                                       *
*    T  v @[Wfds                                          *
*                                                                       *
*************************************************************************/
NOMANGLE UI	CCONV verget(BYTE chn,UC *ver)
{
	UC	*dp;
	UI	i,l;
	UI	bdno;
	UI	bdchn;

	bdno = chn/2;
	bdchn = chn % 2;
	if (MEMAD[bdno] == 0)
		return(0x8007);

	cmd_recv(bdno,bdchn,CVERGET,(DWORD *)version);
	dp = version;
	l = sizeof(version);

	for (i=0;i<l; i++,dp++,ver++){
		*ver = *dp;
	}

	return(0);
}
/**************************************************************************
*                                                                         *
*  ֐  UI pollon(char chn,char polad)                                 *
*                                                                         *
*    T  v |[OI Zbg                                         *
*                                                                         *
***************************************************************************/
NOMANGLE UI  CCONV pollon(BYTE chn,char pollad)
{
	UI	bdno;
	UI	bdchn;

	padr[chn] = pollad;
	bdno = chn/2;
	bdchn = chn % 2;
	if (MEMAD[bdno] == 0)
		return(0x8007);

	if (OPENFLAG[chn] == 0)
		return(0x8006);

	return(cmd_send(bdno,bdchn,CPOLLON,(DWORD *)&padr[chn],1));
}

/**************************************************************************
*                                                                         *
*   ֐  UI polloff(char chn,char polad)                               *
*                                                                         *
*    T  v |[OIt Zbg                                         *
*                                                                         *
***************************************************************************/
NOMANGLE UI	CCONV polloff(BYTE chn,char pollad)
{
	UI	bdno;
	UI	bdchn;

	padr[chn] = pollad;

	bdno = chn/2;
	bdchn = chn % 2;
	if (MEMAD[bdno] == 0)
		return(0x8007);

	if (OPENFLAG[chn] == 0)
		return(0x8006);

	return(cmd_send(bdno,bdchn,CPOLLOFF,(DWORD *)&padr[chn],1));
}


/**************************************************************************
*                                                                         *
*  ֐  UI pollstat(char chn,char polad)                               *
*                                                                         *
*    T  v |[OXe[^X Qbg                                   *
*                                                                         *
***************************************************************************/
NOMANGLE UI  CCONV pollstat(BYTE chn,char pollad)
{
	UI	bdno;
	UI	bdchn;

	padr[chn] = pollad;
	bdno = chn/2;
	bdchn = chn % 2;
	if (MEMAD[bdno] == 0)
		return(0x8007);

	if (OPENFLAG[chn] == 0)
		return(0x8006);

	return(cmd_send(bdno,bdchn,CPOLLRES,(DWORD *)&padr[0],1));
}

/**************************************************************************
*                                                                         *
*  ֐  UI cmendck(char chn)                                           *
*                                                                         *
*    T  v  ҂ߏIĎ@@@                                   *
*                                                                         *
***************************************************************************/
NOMANGLE UI	CCONV cmendck(BYTE chn)
{
	UI	bdno;
	UI	bdchn;
	UI	i;

	bdno = chn/2;
	bdchn = chn % 2;
	if (MEMAD[bdno] == 0)
		return(0x8007);

	if (OPENFLAG[chn] == 0)
		return(0x8006);

	i = cmd_send(bdno,bdchn,CMDENDCK,NULL,0);
	if (i != 0)
	    i |= 0x8000;
	return(i);
}


/************************************************************************
*									*
*    ֐	int ridget( char chn,UC *iddat)				*
*									*
*    T  v	bg@Mhc荞					*
*									*
*	ret = 0x0000 ... ID nothing					*
*	    = 0x00XX ... ID Length					*
*************************************************************************/
NOMANGLE UI	CCONV ridget(BYTE chn,UC *iddat)
{
	UC	*dp;
	int	i;
	UI	bdno;
	UI	bdchn;
        
	bdno = chn/2;
	bdchn = chn % 2;
	if (MEMAD[bdno] == 0)
		return(0x8007);

	if (OPENFLAG[chn] == 0)
		return(0x8006);

	i = cmd_recv(bdno,bdchn,CMDRID,(DWORD *)&WCOMBF[chn]);
	if ( i == 0){
	    return(i);
	}
	dp = (UC *)&WCOMBF[chn];
	memcpy(iddat,dp,i);
	return(i);
}
//========================================================
// Data Read
 UI data_read(UI bdno, UI chn, DWORD dpt, DWORD *dbuff)
 {
	DWORD         len, retlen;
	OVERLAPPED    ol;

        if (chn == 0)
	     ol.Offset = dpt;
        else
	     ol.Offset = dpt + 0x2000;
	len = 0x4;
	ol.OffsetHigh = 0;
	ol.hEvent = NULL;
			
	if (ReadFile(hndFile[bdno], dbuff, 4, &retlen, &ol)){
            return(0);
        }
	else
        {
		return(1);
        }
 }

/*                                                   */
/*   Data Wrtie To PCI Board                         */
/*                                                   */
/*                                                   */
UI data_write(UI bdno,UI chn, DWORD dpt,DWORD *dbuff)
{
	DWORD         len, retlen;
	OVERLAPPED    ol;

        if (chn == 0)
	     ol.Offset = dpt;
        else
	     ol.Offset = dpt + 0x2000;
	len = 0x4;
	ol.OffsetHigh = 0;
	ol.hEvent = NULL;
			
	if (WriteFile(hndFile[bdno], dbuff, 4, &retlen, &ol)){
                return(0);
        }
	else
        {
		return(1);
        }
}

//===
// Flag Read
 UI flag_read(UI bdno, UI chn, DWORD dpt, DWORD *dbuff)
 {
	DWORD         len, retlen;
	OVERLAPPED    ol;

	ol.Offset = 0x4000;
	len = 0x4;
	ol.OffsetHigh = 0;
	ol.hEvent = NULL;
			
	if (ReadFile(hndFile[bdno], dbuff, 4, &retlen, &ol)){
		  *dbuff &= 0x01010101l;
          return(0);
        }
	else
        {
		return(1);
        } 
}

/*   Flag Wrtie To PCI Board                         */
UI flag_write(UI bdno,UI chn, DWORD dpt,DWORD *dbuff)
{
	DWORD         len, retlen;
	OVERLAPPED    ol;

    ol.Offset = 0x4000;
	len = 0x4;
	ol.OffsetHigh = 0;
	ol.hEvent = NULL;
			
	if (WriteFile(hndFile[bdno], dbuff, 4, &retlen, &ol)){
                return(0);
        }
	else
        {
		return(1);
        }
}


/************************************************************************
*                                                                       *
*    ֐ UI cmd_rdy_check( UI bdno, UI chn )                         *
*                                                                       *
*    T  v {[h̃R}h󂯕t`FbN                          *
*                                                                       *
*************************************************************************/
short cmd_rdy_check(UI bdno,UI chn)
{

    do{
        if (flag_read(bdno, chn, 0,(DWORD *) &RFLG[bdno]) == 0){
            if ((RFLG[bdno].flag[chn * 2] == 0x01) && (RFLG[bdno].flag[chn * 2 + 1] == 0x00)){
                 break;
            }
        }
    }while(1);
    return(0);
}

/************************************************************************
*                                                                       *
*    ֐ UI cmd_end_check( UI bdno, UI chn )                         *
*                                                                       *
*    T  v {[h̃R}h󂯕t`FbN                          *
*                                                                       *
*************************************************************************/
short cmd_end_check(UI bdno,UI chn)
{
    do{
        if (flag_read(bdno, chn, 0,(DWORD *) &RFLG[bdno]) == 0){
            if ((RFLG[bdno].flag[chn * 2] == 1) && (RFLG[bdno].flag[chn * 2 + 1] == 1)){
                 break;
            }
        }
    }while(1);
    data_read(bdno, chn, 0,(DWORD *) &WMCMD[bdno * 2 + chn]);
    WFLG[bdno].flag[chn * 2] = 1;
    WFLG[bdno].flag[chn * 2 + 1] = 1;
    flag_write(bdno, chn, 0,(DWORD *) &WFLG[bdno]);

    return(WMCMD[bdno * 2 + chn].stsdt);
}

/************************************************************************
*                                                                       *
*    ֐ UI cmd_set( UI bdno, UI chn )                               *
*                                                                       *
*    T  v {[h̃R}h                                    *
*                                                                       *
*************************************************************************/
short cmd_set(UI bdno,UI chn, UC cmd, UI dlen)
{

    WMCMD[bdno * 2 + chn].stsdt = 0;
    WMCMD[bdno * 2 + chn].dtlen = dlen;
    WMCMD[bdno * 2 + chn].cmddt = cmd;
    data_write(bdno, chn, 0,(DWORD *) &WMCMD[bdno * 2 + chn]);

    WFLG[bdno].flag[chn * 2] = 0x01;
    WFLG[bdno].flag[chn * 2 + 1] = 0x00;
    flag_write(bdno, chn, 0,(DWORD *) &WFLG[bdno]);

     return(0);
}

/************************************************************************
*                                                                       *
*    ֐ UI data_in( UI bdno, UI chn, DWORD *dt )                    *
*                                                                       *
*    T  v {[hf[^󂯎                                  *
*                                                                       *
*************************************************************************/
short data_in(UI bdno, UI chn, DWORD *dt)
{
	UI	dlen,i;
	UI      rt;

        dlen = WMCMD[bdno * 2 + chn].dtlen;
        for (i = 1; i <= (dlen + 3) / 4; i++,dt++){
            rt = data_read(bdno, chn, i * 4, dt);
	}
	return(dlen);
}

/************************************************************************
*                                                                       *
*    ֐ short data_out( UI bdno, UI chn, DWORD *dt , UI dlen)       *
*                                                                       *
*    T  v {[hփf[^𑗂                                        *
*                                                                       *
*************************************************************************/
short data_out(UI bdno, UI chn, DWORD *dt, UI dlen)
{
    UI    i;
    UI    rt;

    for (i = 1; i <= dlen; i++,dt++){
         rt = data_write(bdno,(UC) chn, i * 4, dt);
    }
    return(0);
}

/****************************************************************************
*                                                                           *
*    ֐ short cmd_send( UI bdno, UI chn, UI cmd, UC *dt, UI len )       *
*                                                                           *
*    T  v {[hփR}h𑗂                                          *
*                                                                           *
*****************************************************************************/
short cmd_send(UI bdno, UI chn, UC cmd, DWORD *dt, UI len)
{
    short	rt;
    short	sts;

    // cmd end check
    rt = cmd_rdy_check(bdno,chn);
    // data trans
    rt = data_out(bdno, chn, dt, (len + 3) / 4);
    // cmd set
    rt = cmd_set(bdno, chn, cmd, len);
    // cmd end check & Get Status
    sts = cmd_end_check(bdno, chn);
    return(sts);
}

/****************************************************************************
*                                                                           *
*    ֐ short cmd_recv( UI bdno,UI chn, UI cmd, UC *dt )                *
*                                                                           *
*    T  v {[hXe[^X󂯎                                  *
*                                                                           *
*****************************************************************************/
short cmd_recv(UI bdno,UI chn,UC cmd,DWORD *dt)
{
    short	rt;
    short	sts;

    // cmd end check
    rt = cmd_rdy_check(bdno,chn);

    // cmd set
    rt = cmd_set(bdno,chn, cmd, 0);
    // cmd end check
    sts = cmd_end_check(bdno,chn);
    if (dt == NULL)
		return(sts);
	// data read
    rt =  data_in(bdno, chn, dt);
    return(sts);
}


/************************************************************************
*                                                                       *
*    ֐ UI sizeck( sp )                                             *
*                                                                       *
*    T  v TCỸ`FbN                                      *
*                                                                       *
*       UC  *sp ;                                             *
*                                                                       *
*************************************************************************/
UI sizeck(UC *sp)
{
	UI	i;

	for (i=0; ; i++, sp++){
	    if (*sp == 0x00)
		return(i);
	}
}
   	  


